package com.pacsol.caseview.dataproviders;

import java.util.List;
import java.util.stream.Stream;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.vaadin.flow.data.provider.AbstractDataProvider;
import com.vaadin.flow.data.provider.Query;

public class CaseDataProvider<F> extends AbstractDataProvider<com.pacsol.caseview.models.CaseModel, F> {
	private static Logger logger = LoggerFactory.getLogger(CaseDataProvider.class);

	public CaseDataProvider() {
	}

	@Override
	public Stream<com.pacsol.caseview.models.CaseModel> fetch(Query<com.pacsol.caseview.models.CaseModel, F> query) {
		int limit = query.getLimit();
		int offset = query.getOffset();
    	EntityManagerFactory emf = Persistence.createEntityManagerFactory("caseview");
    	EntityManager em = emf.createEntityManager();
    	EntityTransaction et = em.getTransaction();
    	et.begin();
		javax.persistence.TypedQuery<com.pacsol.caseview.models.CaseModel> qry = em.createQuery("From com.pacsol.caseview.models.CaseModel", com.pacsol.caseview.models.CaseModel.class);
		qry.setFirstResult(offset);
		qry.setMaxResults(limit);
		List <com.pacsol.caseview.models.CaseModel> rcds = qry.getResultList();
		int count = rcds.size();
	    logger.info("Retrieved {} records from com.pacsol.caseview.models.CaseModel at offset {} and limit {}.", count, offset, limit);
    	et.commit();
    	em.close();
    	Stream<com.pacsol.caseview.models.CaseModel> st = rcds.stream();
    	return(st);
    }

	@Override
	public boolean isInMemory() {
		return false;
	}

	@Override
	public int size(Query<com.pacsol.caseview.models.CaseModel, F> query) {
    	EntityManagerFactory emf = Persistence.createEntityManagerFactory("caseview");
    	EntityManager em = emf.createEntityManager();
    	EntityTransaction et = em.getTransaction();
    	et.begin();
    	javax.persistence.Query queryTotal = em.createQuery("Select count(f.id) from com.pacsol.caseview.models.CaseModel f");
    	Long count = (Long)queryTotal.getSingleResult();
	    logger.info("Total records is {}.", count);
    	et.commit();
    	em.close();
    	return(count.intValue());
	}
	

}
